import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

local height = 48;
local barWidth = 119;
local maxMember = 5;
local bigFontMargin = 0;
local bigFontMargin2 = 0;

local nameFS = Turbine.UI.Color(35/256,134/256,35/256)		--Green
local nameSelf = Turbine.UI.Color(6/256,248/256,248/256)	--Cyan
--local NPC = Turbine.UI.Color(0/256,209/256,209/256)	--Cyan

--local nameGray = Turbine.UI.Color(209/256,209/256,209/256); -- Foe color
--local nameGreen = Turbine.UI.Color(209/256,209/256,209/256)
--local nameBlue = Turbine.UI.Color(209/256,209/256,209/256)
--local nameCyan = Turbine.UI.Color(209/256,209/256,209/256)
local nameWhite = Turbine.UI.Color(256/256,256/256,256/256)
local nameOrange = Turbine.UI.Color(256/256,0.4,0/256)
--local nameRed = Turbine.UI.Color(209/256,209/256,209/256)
--local namePurple = Turbine.UI.Color(209/256,209/256,209/256)

NTAWindow = class(Turbine.UI.Window);
function NTAWindow:Constructor()
	Turbine.UI.Window.Constructor( self );
	self:SetWantsUpdates(false);

	self.settings = NTAWindowLoadSettings()

	self:SetPosition( self.settings.x, self.settings.y );

	self.dragging = false;
	self.move = true;

	self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
	self.target = self.player.GetTarget();
	self.party = self.player:GetParty()
	self.memberCount = self.player:GetParty()
	self.name = self.player:GetName();

	self.TACount = 0;

	self.AWLabel=Turbine.UI.Label();
	self.AWLabel:SetParent(self);
	self.AWLabel:SetPosition( 0, 0 );
	self.AWLabel:SetText("New Assist Window" );
	self.AWLabel:SetSize(270, 20 );
	self.AWLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.AWLabel:SetForeColor(Turbine.UI.Color(229/256,209/256,136/256))
	self.AWLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
	self.AWLabel:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	self.AWLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);

	self.frameLabel=Turbine.UI.Label();
	self.frameLabel:SetParent(self);
	self.frameLabel:SetPosition( 0, 17 );
	self.frameLabel:SetBackColor(Turbine.UI.Color(0.2,0,0,0));

	self.AWLabel.MouseDown = function(sender,args)
		self.MouseDown(self,args);
	end
	self.AWLabel.MouseMove = function(sender,args)
		self.MouseMove(self,args);
	end
	self.AWLabel.MouseUp = function(sender,args)
		self.MouseUp(self,args);
	end

	self.TA = {}
	for i=1, maxMember do
		self.TA[i] = {}

		self.TA[i].NameLabel=Turbine.UI.Label();
		self.TA[i].NameLabel:SetParent(self.frameLabel);
		self.TA[i].NameLabel:SetPosition( 0, height*(i-1)+4);
		self.TA[i].NameLabel:SetSize(270, 20);
		self.TA[i].NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
		self.TA[i].NameLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
		self.TA[i].NameLabel:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
		self.TA[i].NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft);

		self.TA[i].MoraleBar=Turbine.UI.Label();
		self.TA[i].MoraleBar:SetParent(self.frameLabel);
		self.TA[i].MoraleBar:SetPosition( 1, height*(i-1)+23);

		self.TA[i].PowerBar=Turbine.UI.Label();
		self.TA[i].PowerBar:SetParent(self.frameLabel);

		self.TA[i].MoraleLabel=Turbine.UI.Label();
		self.TA[i].MoraleLabel:SetParent(self.frameLabel);
		self.TA[i].MoraleLabel:SetPosition( 1, height*(i-1)+21);
		self.TA[i].MoraleLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
		self.TA[i].MoraleLabel:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
		self.TA[i].MoraleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);

		self.TA[i].PowerLabel =Turbine.UI.Label();
		self.TA[i].PowerLabel:SetParent(self.frameLabel);
		self.TA[i].PowerLabel:SetForeColor(nameWhite)
		self.TA[i].PowerLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
		self.TA[i].PowerLabel:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
		self.TA[i].PowerLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);

		self.TA[i].Entity =Turbine.UI.Lotro.EntityControl();
		self.TA[i].Entity:SetParent(self.frameLabel);
		self.TA[i].Entity:SetPosition( 0, height*(i-1));
		self.TA[i].Entity:SetSize(135, height);

		self.TA[i].TargetLabel=Turbine.UI.Label();
		self.TA[i].TargetLabel:SetParent(self.frameLabel);
		self.TA[i].TargetLabel:SetPosition( 0, height*(i-1)+4);
		self.TA[i].TargetLabel:SetSize(266, 20);
		self.TA[i].TargetLabel:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		self.TA[i].TargetLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
		self.TA[i].TargetLabel:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
		self.TA[i].TargetLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopRight);

		self.TA[i].TargetMoraleBar=Turbine.UI.Label();
		self.TA[i].TargetMoraleBar:SetParent(self.frameLabel);
		self.TA[i].TargetMoraleBar:SetPosition( 140, height*(i-1)+23);

		self.TA[i].TargetPowerBar=Turbine.UI.Label();
		self.TA[i].TargetPowerBar:SetParent(self.frameLabel);

		self.TA[i].TargetMoraleLabel=Turbine.UI.Label();
		self.TA[i].TargetMoraleLabel:SetParent(self.frameLabel);
		self.TA[i].TargetMoraleLabel:SetPosition( 140, height*(i-1)+21);
		self.TA[i].TargetMoraleLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
		self.TA[i].TargetMoraleLabel:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
		self.TA[i].TargetMoraleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);

		self.TA[i].TargetPowerLabel =Turbine.UI.Label();
		self.TA[i].TargetPowerLabel:SetParent(self.frameLabel);
		self.TA[i].TargetPowerLabel:SetForeColor(nameWhite)
		self.TA[i].TargetPowerLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
		self.TA[i].TargetPowerLabel:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
		self.TA[i].TargetPowerLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);

		self.TA[i].TargetEntity =Turbine.UI.Lotro.EntityControl();
		self.TA[i].TargetEntity:SetParent(self.frameLabel);
		self.TA[i].TargetEntity:SetPosition( 135, height*(i-1));
		self.TA[i].TargetEntity:SetSize(135, height);

	end

	self.player.TargetChanged = NTAWindow.setMyTarget

	self.KeyDown = function(sender, args)
		if args.Action == 0x100000B3 then
			if self.visible == true then
				self:SetVisible(false); 
				self.visible = false;
			else
				self:SetVisible(true); 
				self.visible = true;
			end
		end
	end
	
	self.visible=true;
	self:SetWantsUpdates(true);
	self:SetWantsKeyEvents(true);
	
	self:initWindow()
	self:redraw()
end


function NTAWindow:setMyTarget(sender, args)
	myNTAWindow:setMyTarget2(sender, args)
end

function NTAWindow:setMyTarget2(sender, args)
	self.target = self.player:GetTarget();

	for key, value in pairs(self.TA) do
		if value.TargetLabel.updateColor then
			if self.target ~= nil and value.target ~= nil and
			   value.target:IsA(Turbine.Gameplay.Actor) and 
			   self.target:IsA(Turbine.Gameplay.Actor) and 
			   value.target:GetMorale() ~= nil and value.target:GetMorale() ~= value.target:GetMaxMorale() and
			   value.target:GetMorale() == self.target:GetMorale() then
				value.TargetLabel:SetForeColor(nameOrange)
--Turbine.Shell.WriteLine("MT:Orange");
				value.TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleOrangeB.tga" or "Risko/NewTargetAssist/images/moraleOrange.tga");
			else
				value.TargetLabel:SetForeColor(nameWhite)
--Turbine.Shell.WriteLine("MT:White");
				value.TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleOrangeB.tga" or "Risko/NewTargetAssist/images/moraleOrange.tga");
			end
		end

	end
end


function NTAWindow:initWindow()
	self.TACount = 0;

	self.party = self.player:GetParty()
	self.memberCount = self.party and self.party:GetMemberCount() or 1
	if self.party ~= nil then
		for i=1, self.memberCount do
			local member = self.party:GetMember(i)
			if self.party:IsAssistTarget(member) then
				self.TACount = self.TACount + 1;
				self:setMember(self.TACount, member);
			end
		end
	end
	
	self:SetSize(270,self.TACount*height+17);
	self.frameLabel:SetSize(270, self.TACount*height);
	
	if self.TACount == 0 then
		self:SetVisible(false); 
	else
		self:SetVisible(self.settings.show); 
	end
end


function NTAWindow:redraw()

	if self.party == nil then return; end

	local m = self.settings.mfont;

	if m then
		bigFontMargin = 3
		bigFontMargin2 = 4
	else
		bigFontMargin = 0
		bigFontMargin2 = 0
	end
	
	for i=1, maxMember do
		self.TA[i].NameLabel:SetFont(m and Turbine.UI.Lotro.Font.Verdana14 or Turbine.UI.Lotro.Font.Verdana12);
		self.TA[i].NameLabel:SetText(self.TA[i].NameLabel:GetText());

		self.TA[i].MoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleGreenB.tga" or "Risko/NewTargetAssist/images/moraleGreen.tga");
		self.TA[i].MoraleBar:SetSize(barWidth, 6+bigFontMargin);

		self.TA[i].PowerBar:SetPosition( 1, height*(i-1)+30+bigFontMargin2);
		self.TA[i].PowerBar:SetBackground(m and "Risko/NewTargetAssist/images/PowerBlueB.tga" or "Risko/NewTargetAssist/images/PowerBlue.tga");
		self.TA[i].PowerBar:SetSize(barWidth, 6+bigFontMargin);

		self.TA[i].MoraleLabel:SetFont(m and Turbine.UI.Lotro.Font.Verdana12 or Turbine.UI.Lotro.Font.Verdana10);
		self.TA[i].MoraleLabel:SetSize(barWidth, 8+bigFontMargin);

		self.TA[i].PowerLabel:SetPosition( 1, height*(i-1)+28+bigFontMargin2);
		self.TA[i].PowerLabel:SetFont(m and Turbine.UI.Lotro.Font.Verdana12 or Turbine.UI.Lotro.Font.Verdana10);
		self.TA[i].PowerLabel:SetSize(barWidth, 8+bigFontMargin);

		self.TA[i].TargetLabel:SetFont(m and Turbine.UI.Lotro.Font.Verdana14 or Turbine.UI.Lotro.Font.Verdana12);
		self.TA[i].TargetLabel:SetText(self.TA[i].TargetLabel:GetText());

		local fellow = false
		local targetname = self.TA[i].target and self.TA[i].target:GetName() or ""
		self.memberCount = self.player:GetParty():GetMemberCount()
		for j=1, self.memberCount do
			local member = self.party:GetMember(j)
			if targetname == member:GetName() then
				fellow = true;
				break;
			end
		end

		if fellow == true then
			self.TA[i].TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleGreenB.tga" or "Risko/NewTargetAssist/images/moraleGreen.tga");
		else
			self.TA[i].TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleOrangeB.tga" or "Risko/NewTargetAssist/images/moraleOrange.tga");
		end

		self.TA[i].TargetMoraleBar:SetSize(barWidth, 6+bigFontMargin);

		self.TA[i].TargetPowerBar:SetPosition( 140, height*(i-1)+30+bigFontMargin2);
		self.TA[i].TargetPowerBar:SetBackground(m and "Risko/NewTargetAssist/images/PowerBlueB.tga" or "Risko/NewTargetAssist/images/PowerBlueB.tga");
		self.TA[i].TargetPowerBar:SetSize(barWidth, 6+bigFontMargin);

		self.TA[i].TargetMoraleLabel:SetFont(m and Turbine.UI.Lotro.Font.Verdana12 or Turbine.UI.Lotro.Font.Verdana10);
		self.TA[i].TargetMoraleLabel:SetSize(barWidth, 8+bigFontMargin);

		self.TA[i].TargetPowerLabel:SetPosition( 140, height*(i-1)+28+bigFontMargin2);
		self.TA[i].TargetPowerLabel:SetFont(m and Turbine.UI.Lotro.Font.Verdana12 or Turbine.UI.Lotro.Font.Verdana10);

		self.TA[i].TargetPowerLabel:SetSize(barWidth, 8+bigFontMargin);

		self:updateMP(self.TA[i].member, i);
		self:updateTargetMP(self.TA[i].target, i);
	end
	if self.TACount == 0 then
		self:SetVisible(false); 
	else
		self:SetVisible(self.settings.show); 
	end
end

function NTAWindow:setMember(i, member)
	member.I = i;
	local name = member:GetName()
	self.TA[i].member = member
	self.TA[i].name = name
	self.TA[i].Entity:SetEntity(member);
	self.TA[i].NameLabel:SetText(name);
	self.TA[i].name = name;
	if name == self.name then
		self.TA[i].NameLabel:SetForeColor(nameSelf)
	else
		self.TA[i].NameLabel:SetForeColor(nameFS)
	end
	member.TargetChanged = NTAWindow.localTargetChanged;

	member.MoraleChanged = NTAWindow.localMPChanged;
	member.MaxMoraleChanged = NTAWindow.localMPChanged;
	member.PowerChanged = NTAWindow.localMPChanged;
	member.MaxPowerChanged = NTAWindow.localMPChanged;

	local target = member:GetTarget()
	self.TA[i].target = target
	self:setTarget(i, target);

	self:updateMP(member, i);
end

function NTAWindow:setTarget(i, target)
	self.TA[i].target = target
	self.TA[i].TargetEntity:SetEntity(target);
	
	if target ~= nil and target:IsA(Turbine.Gameplay.Actor) then
		target.I = i;
		local name = target:GetName();
		self.TA[i].TargetLabel:SetVisible(true)
		self.TA[i].TargetMoraleBar:SetVisible(true)
		self.TA[i].TargetPowerBar:SetVisible(true)
		self.TA[i].TargetMoraleLabel:SetVisible(true)
		self.TA[i].TargetPowerLabel:SetVisible(true)

		local m = self.settings.mfont;
		self.TA[i].TargetPowerBar:SetBackground(m and "Risko/NewTargetAssist/images/PowerBlueB.tga" or "Risko/NewTargetAssist/images/PowerBlueB.tga");
		if name == self.name then
			self.TA[i].TargetLabel.updateColor = false;
			self.TA[i].TargetLabel:SetForeColor(nameSelf)
			self.TA[i].TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleGreenB.tga" or "Risko/NewTargetAssist/images/moraleGreen.tga");
		else
			local fellow = false
			self.memberCount = self.player:GetParty():GetMemberCount()
			for j=1, self.memberCount do
				local member = self.party:GetMember(j)
				if name == member:GetName() then
					fellow = true;
					break;
				end
			end
			if fellow == true then
			   self.TA[i].TargetLabel.updateColor = false;
				self.TA[i].TargetLabel:SetForeColor(nameFS)
				self.TA[i].TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleGreenB.tga" or "Risko/NewTargetAssist/images/moraleGreen.tga");
			elseif target ~= nil and self.target ~= nil and 
			   target:IsA(Turbine.Gameplay.Actor) and
			   target:GetMorale() ~= nil and 
			   target:GetMorale() ~= target:GetMaxMorale() and 
			   self.target:IsA(Turbine.Gameplay.Actor) and
			   target:GetMorale() == self.target:GetMorale() then
			   self.TA[i].TargetLabel.updateColor = true;
				self.TA[i].TargetLabel:SetForeColor(nameOrange)
--Turbine.Shell.WriteLine("CT:Orange");
				self.TA[i].TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleOrangeB.tga" or "Risko/NewTargetAssist/images/moraleOrange.tga");
			else
			   self.TA[i].TargetLabel.updateColor = true;
				self.TA[i].TargetLabel:SetForeColor(nameWhite)
--Turbine.Shell.WriteLine("CT:White");
				self.TA[i].TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleOrangeB.tga" or "Risko/NewTargetAssist/images/moraleOrange.tga");
			end
		end
		self.TA[i].TargetLabel:SetText(name);

		target.MoraleChanged = NTAWindow.localTargetMPChanged;
		target.MaxMoraleChanged = NTAWindow.localTargetMPChanged;
		target.PowerChanged = NTAWindow.localTargetMPChanged;
		target.MaxPowerChanged = NTAWindow.localTargetMPChanged;

		self:updateTargetMP(target, i);
	else
		self.TA[i].TargetLabel:SetText("");
		self.TA[i].TargetLabel:SetVisible(false)
		self.TA[i].TargetMoraleBar:SetVisible(false)
		self.TA[i].TargetPowerBar:SetVisible(false)
		self.TA[i].TargetMoraleLabel:SetVisible(false)
		self.TA[i].TargetPowerLabel:SetVisible(false)
	end

end

function NTAWindow:addTA(name)
	if self.party == nil then self.party = self.player:GetParty(); end


	self.memberCount = self.party:GetMemberCount()

	for i=1, self.memberCount do
		local member = self.party:GetMember(i)
		if member:GetName() == name then
			self.TACount = self.TACount + 1;
			self:setMember(self.TACount, member);
			break
		end
	end

	self:SetSize(270,self.TACount*height+17);
	self.frameLabel:SetSize(270, self.TACount*height);

	self:SetVisible(true); 
end

function NTAWindow:deleteAll()
	for i=1, self.TACount do
		member = self.TA[i].member;

		member.TargetChanged = nil;
		member.MoraleChanged = nil;
		member.MaxMoraleChanged = nil;
		member.PowerChanged = nil;
		member.MaxPowerChanged = nil;

		target = self.TA[i].target;
		if target ~= nil then
			target.MoraleChanged = nil;
			target.MaxMoraleChanged = nil;
			target.PowerChanged = nil;
			target.MaxPowerChanged = nil;
		end

		self.TA[i].member = nil
		self.TA[i].target = nil
	end
	self.TACount = 0;
	self:SetVisible(false); 
end

function NTAWindow:deleteTA(name)
	local removed = false
	
	for i=1, self.TACount do
		local member = self.TA[i].member
		if member:GetName() == name then
			self.TA[i].member.TargetChanged = nil;
			self.TA[i].member.MoraleChanged = nil;
			self.TA[i].member.MaxMoraleChanged = nil;
			self.TA[i].member.PowerChanged = nil;
			self.TA[i].member.MaxPowerChanged = nil;

			target = self.TA[i].target;
			if target ~= nil then
				target.MoraleChanged = nil;
				target.MaxMoraleChanged = nil;
				target.PowerChanged = nil;
				target.MaxPowerChanged = nil;
			end

			for j=i, self.TACount-1 do
				self:setMember(j, self.TA[j+1].member);
			end
			removed = true;
			break;
		end
	end
	if removed == false then return; end

	self.TA[self.TACount].member = nil
	self.TA[self.TACount].Entity:SetEntity(nil)
	self.TACount = self.TACount - 1;
	self:SetSize(270,self.TACount*height+17);
	self.frameLabel:SetSize(270, self.TACount*height);

	if name == self.name then
		self.player.TargetChanged = NTAWindow.setMyTarget
	end


	if self.TACount == 0 then
		self:SetVisible(false); 
	else
		self:SetVisible(true); 
	end
end

function NTAWindow:deleteTAByLeaving(name)
	local removed = false
	for i=1, self.TACount do
		local membername = self.TA[i].name
		if membername == name then
			self.TA[i].member.TargetChanged = nil;
			self.TA[i].member.MoraleChanged = nil;
			self.TA[i].member.MaxMoraleChanged = nil;
			self.TA[i].member.PowerChanged = nil;
			self.TA[i].member.MaxPowerChanged = nil;

			target = self.TA[i].target;
			if target ~= nil then
				target.MoraleChanged = nil;
				target.MaxMoraleChanged = nil;
				target.PowerChanged = nil;
				target.MaxPowerChanged = nil;
			end

			for j=i, self.TACount-1 do
				self:setMember(j, self.TA[j+1].member);
			end
			removed = true;
			break;
		end
	end
	if removed == false then return; end

	self.TA[self.TACount].member = nil
	self.TA[self.TACount].Entity:SetEntity(nil)
	self.TACount = self.TACount - 1;
	self:SetSize(270,self.TACount*height+17);
	self.frameLabel:SetSize(270, self.TACount*height);

	if self.TACount == 0 then
		self:SetVisible(false); 
	else
		self:SetVisible(true); 
	end
end

function NTAWindow.localTargetChanged(sender, args)
	myNTAWindow:updateTarget(sender, args)
end

function NTAWindow:linkdead(name)
	for i=1, self.TACount do
		local membername = self.TA[i].name
		if membername == name then
			self.TA[i].linkdead = true;
			self.TA[i].MoraleBar:SetBackground("Risko/NewTargetAssist/images/gray.tga");
			self.TA[i].PowerBar:SetBackground("Risko/NewTargetAssist/images/gray.tga");
			self.TA[i].MoraleLabel:SetText("Link dead");
			self.TA[i].PowerLabel:SetText("");

			self.TA[i].TargetLabel:SetText("");
			self.TA[i].TargetMoraleBar:SetBackground("Risko/NewTargetAssist/images/gray.tga");
			self.TA[i].TargetPowerBar:SetBackground("Risko/NewTargetAssist/images/gray.tga");
			self.TA[i].TargetMoraleLabel:SetText("Link dead");
			self.TA[i].TargetPowerLabel:SetText("");
			break;
		end
	end
end

function NTAWindow:updateTarget(sender, args)

	local oldTarget = self.TA[sender.I].target;
	if oldTarget ~= nil then
		oldTarget.MoraleChanged = nil;
		oldTarget.MaxMoraleChanged = nil;
		oldTarget.PowerChanged = nil;
		oldTarget.MaxPowerChanged = nil;
	end

	local target = sender:GetTarget()
	if sender:GetName() == self.name then
		self.target = target;
	end
	self:setTarget(sender.I, target);
end

function NTAWindow.localMPChanged(sender, args)
	myNTAWindow:updateMP(sender, sender.I)
end

function NTAWindow:updateMP(sender,i)
	if sender == nil then return end

	if self.TA[sender.I].linkdead == true then
		local m = self.settings.mfont;
		self.TA[sender.I].linkdead = false
		self.TA[i].MoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleGreenB.tga" or "Risko/NewTargetAssist/images/moraleGreen.tga");
		self.TA[i].PowerBar:SetBackground(m and "Risko/NewTargetAssist/images/PowerBlueB.tga" or "Risko/NewTargetAssist/images/PowerBlue.tga");
	end

	local morale=sender:GetMorale();
	local maxmorale=sender:GetMaxMorale();
	local p=morale/maxmorale;
	if p > 1 then p = 1 end

	if maxmorale == 0 then
	end


	local str = ""
	if self.settings.showCurrent then str= str..self:comma(morale); end
	if self.settings.showMax then str= str.."/"..self:comma(maxmorale); end
	if self.settings.showPercent then 
		local pstr= string.format("%.1f",math.floor(1000*p)/10);
		if pstr=="100.0" then
			pstr="100"
		end
		str = str..((str == "") and "" or " ").. pstr.."%";
	end

	self.TA[i].MoraleLabel:SetText(str);
	local w = math.floor(barWidth*p)
	self.TA[i].MoraleBar:SetSize(w, 6+bigFontMargin);

	local power=sender:GetPower();
	local maxPower=sender:GetMaxPower();
	local p=power/maxPower;
	if p > 1 then p = 1 end

	local str = ""
	if self.settings.showCurrent then str= str..self:comma(power); end
	if self.settings.showMax then str= str.."/"..self:comma(maxPower); end
	if self.settings.showPercent then 
		local pstr= string.format("%.1f",math.floor(1000*p)/10);
		if pstr=="100.0" then
			pstr="100"
		end
		str = str..((str == "") and "" or " ").. pstr.."%";
	end

	self.TA[i].PowerLabel:SetText(str);
	local w = math.floor(barWidth*p)
	self.TA[i].PowerBar:SetSize(w, 6+bigFontMargin);
end

function NTAWindow.localTargetMPChanged(sender, args)
	myNTAWindow:updateTargetMP(sender, sender.I)
end

function NTAWindow:updateTargetMP(sender,i)
	if sender == nil then
		if self.TA[i].linkdead == true then
			self.TA[i].TargetMoraleLabel:SetText("Link dead");
		else
			self.TA[i].TargetMoraleLabel:SetText("");
		end
		self.TA[i].TargetPowerLabel:SetText("");

		self.TA[i].TargetMoraleBar:SetSize(0, 6+bigFontMargin);
		self.TA[i].TargetPowerBar:SetSize(0, 6+bigFontMargin);
		return
	end

	if self.TA[i].TargetLabel.updateColor then
--Turbine.Shell.WriteLine("MP:"..string.format("%s %s", tostring(sender), tostring(self.target)));
		
		if sender ~= nil and self.target ~= nil and sender:IsA(Turbine.Gameplay.Actor) and self.target:IsA(Turbine.Gameplay.Actor) then

			if sender:GetMorale() ~= sender:GetMaxMorale() and sender:GetMorale() == self.target:GetMorale() then
				-- sender:GetMorale() may sometime give false value (zero)
--Turbine.Shell.WriteLine("MP:Orange "..string.format("%d %d", sender:GetMorale(), self.target:GetMorale()));
				self.TA[i].TargetLabel:SetForeColor(nameOrange)
				self.TA[i].TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleOrangeB.tga" or "Risko/NewTargetAssist/images/moraleOrange.tga");
			else
--Turbine.Shell.WriteLine("MP:White  "..string.format("%d %d", sender:GetMorale(), self.target:GetMorale()));
--Turbine.Shell.WriteLine("MP:White  "..string.format("%s - %s", tostring(sender), tostring(self.target)));
--Turbine.Shell.WriteLine("MP:White- "..string.format("%s - %s", sender:GetName(), self.target:GetName()));
				self.TA[i].TargetLabel:SetForeColor(nameWhite)
				self.TA[i].TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleOrangeB.tga" or "Risko/NewTargetAssist/images/moraleOrange.tga");
			end

		end
	end

	if sender:IsA(Turbine.Gameplay.Actor) == false then return end;
	
	local morale=sender:GetMorale();
	local maxmorale=sender:GetMaxMorale();
	local p= maxmorale ~= 0 and morale/maxmorale or 0;
	if p > 1 then p = 1 end

	local str = ""
	if self.settings.showCurrent then str= str..self:comma(morale); end
	if self.settings.showMax then str= str.."/"..self:comma(maxmorale); end
	if self.settings.showPercent then 
		local pstr= string.format("%.1f",math.floor(1000*p)/10);
		if pstr=="100.0" then
			pstr="100"
		end
		str = str..((str == "") and "" or " ").. pstr.."%";
	end
	if p == 0 then str = ""; end

	self.TA[i].TargetMoraleLabel:SetText(str);
	local w = math.floor(barWidth*p)
	self.TA[i].TargetMoraleBar:SetPosition( 140+barWidth-w, height*(i-1)+23);
	self.TA[i].TargetMoraleBar:SetSize(w, 6+bigFontMargin);

	local power=sender:GetPower();
	local maxPower=sender:GetMaxPower();
	local p=maxPower ~= 0 and power/maxPower or 0;
	if p > 1 then p = 1 end

	local str = ""
	if self.settings.showCurrent then str= str..self:comma(power); end
	if self.settings.showMax then str= str.."/"..self:comma(maxPower); end
	if self.settings.showPercent then 
		local pstr= string.format("%.1f",math.floor(1000*p)/10);
		if pstr=="100.0" then
			pstr="100"
		end
		str = str..((str == "") and "" or " ").. pstr.."%";
	end
	if p == 0 then str = ""; end

	self.TA[i].TargetPowerLabel:SetText(str);
	local w = math.floor(barWidth*p)
	self.TA[i].TargetPowerBar:SetPosition( 140+barWidth-w, height*(i-1)+30+bigFontMargin2);
	self.TA[i].TargetPowerBar:SetSize(w, 6+bigFontMargin);
end

function NTAWindow:comma(n)
	if n > 1000000 then
		if self.settings.shrinkNum then
			s = string.format("%.1f", n/1000000).."M"
		else
			s = tostring(math.floor(n/1000000))..","..string.format("%03d",math.floor(n/1000)%1000)..","..string.format("%03d",math.floor(n%1000))
		end
	elseif n > 1000 then
		if self.settings.shrinkNum then
			s = string.format("%.1f", n/1000).."k"
		else
			s = tostring(math.floor(n/1000)%1000)..","..string.format("%03d",math.floor(n%1000));
		end
	else
		s = tostring(math.floor(n))
	end
	return tostring(s);
end

function NTAWindow:Update(args)
--	frame = frame + 1;
--	self:showMorale();

	for key, value in pairs(self.TA) do
		if value.TargetLabel.updateColor then
			if self.target ~= nil and value.target ~= nil and
			   value.target:IsA(Turbine.Gameplay.Actor) and 
			   self.target:IsA(Turbine.Gameplay.Actor) and 
			   value.target:GetMorale() ~= nil and value.target:GetMorale() ~= value.target:GetMaxMorale() and
			   value.target:GetMorale() == self.target:GetMorale() then
				value.TargetLabel:SetForeColor(nameOrange)
--Turbine.Shell.WriteLine("MT:Orange");
				value.TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleOrangeB.tga" or "Risko/NewTargetAssist/images/moraleOrange.tga");
			else
				value.TargetLabel:SetForeColor(nameWhite)
---Turbine.Shell.WriteLine("MT:White");
				value.TargetMoraleBar:SetBackground(m and "Risko/NewTargetAssist/images/moraleOrangeB.tga" or "Risko/NewTargetAssist/images/moraleOrange.tga");
			end
		end
	end
end

function NTAWindow:MouseDown(args)
	if args.Button == Turbine.UI.MouseButton.Left and self.move then
		self.dragStartX = args.X;
		self.dragStartY = args.Y;
		self.dragging = true;
	end
end

function NTAWindow:MouseMove(args)

	if self.dragging then
		local x, y = self:GetPosition();
		x = x + (args.X - self.dragStartX);
		y = y + (args.Y - self.dragStartY);
		self.settings.x = x;
		self.settings.y = y;
		self:SetPosition(x, y);
	end
end

function NTAWindow:MouseUp(args)
	if args.Button == Turbine.UI.MouseButton.Left then
		self:SaveSettings();
		self.dragging = false;
	end
end

function NTAWindowLoadSettings()
	local settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "NewTargetWindow" );
	if type( settings ) ~= "table" then
		settings={ };
	end
	if (not settings.x) then settings.x = 400; end
	if (not settings.y) then settings.y = 400; end
	if (settings.show==nil) then settings.show = true; end
	if (settings.mfont==nil) then settings.show = false; end
	if (settings.shrinkNum==nil) then settings.shrinkNum = false; end
	if (settings.showCurrent==nil) then settings.showCurrent = false; end
	if (settings.showMax==nil) then settings.showMax = false; end
	if (settings.showPercent==nil) then settings.showPercent = true; end

	return settings;
end

function NTAWindow:SaveSettings()
	Turbine.PluginData.Save( Turbine.DataScope.Character, "NewTargetWindow", self.settings );
end

function NTAWindow:chatStandardMessage(m)
	name = m:match("(.+) has joined your Fellowship"); -- A member Joined fellowship or RAID
	if name == nil then name = m:match("(.+) has joined your Raid"); end
	if name ~= nil then
		-- A member joined
	end

	name = m:match("You have joined a (Fellowship)"); -- Joined fellowship or RAID
	if name == nil then name = m:match("You have joined a (Raid)"); end
	if name ~= nil then
		self.party = self.player:GetParty()
		self:redraw()
		-- Joined Fellowship
	end

	name = m:match("(.+) is now a raid assist target."); -- RAID assist
	if name ~= nil then
		self:addTA(name);
	end

	name = m:match("(.+) is no longer a raid assist target"); -- RAID assist removed
	if name ~= nil then
		self:deleteTAByLeaving(name);
	end

	name = m:match("(.+) has left your Fellowship."); -- A member left
	if name == nil then name = m:match("(.+) has left your Fellowship."); end
	if name ~= nil then
		self:deleteTAByLeaving(name);
	end

	name = m:match("Your (Fellowship) has been disbanded");
	if name == nil then name = m:match("Your (Raid) has been disbanded"); end
	if name ~= nil then
		self:deleteAll()
		self.party = nil;
	end

	name = m:match("You leave your (Fellowship)");
	if name == nil then name = m:match("You leave your Raid"); end
	if name ~= nil then
		self:deleteAll()
		self.party = nil;
	end

	name = m:match("(.+) has gone link dead from your Fellowship.");
	if name == nil then name = m:match("(.+) has gone link dead from your Raid."); end
	if name ~= nil then
		self:linkdead(name)
	end

-- (.+) has been dismissed from your Fellowship.
-- You dismiss (.+) from the fellowship.
end

