import "Turbine.UI.Lotro"

OptionWindow = class(Turbine.UI.Control);

function OptionWindow:Constructor(settings)
    Turbine.UI.Control.Constructor(self);

	self.settings = settings;
	self:SetPosition( 200, 200 );
	self:SetSize( 270, 400 );
	self:SetVisible(true);

	self:PlaceControls(self);
end

function OptionWindow:GetOptionControl()
	local control = Turbine.UI.Control();
	control:SetSize( 270, 400 );
	self:PlaceControls(control);
	self:SetVisible(true);
	return control;
end

function OptionWindow:PlaceControls(parent)
	-- Show morale percent
	self.showCB = Turbine.UI.Lotro.CheckBox();
	self.showCB:SetParent(parent);
	self.showCB:SetText(" Show panel");
	self.showCB:SetPosition( 20, 40 );
	self.showCB:SetSize( 230, 25 );
	self.showCB:SetChecked(myNTAWindow.settings.show);
	self.showCB.CheckedChanged = function (sender, args) myNTAWindow:show(self.showCB:IsChecked()) ; end

	-- Show morale percent
	self.showCB = Turbine.UI.Lotro.CheckBox();
	self.showCB:SetParent(parent);
	self.showCB:SetText(" Medium font");
	self.showCB:SetPosition( 20, 70 );
	self.showCB:SetSize( 230, 25 );
	self.showCB:SetChecked(myNTAWindow.settings.mfont);
	self.showCB.CheckedChanged = function (sender, args) myNTAWindow:mfont(self.showCB:IsChecked()) ; end

	-- Show shrinked number
	self.showShrinkNumCB = Turbine.UI.Lotro.CheckBox();
	self.showShrinkNumCB:SetParent(parent);
	self.showShrinkNumCB:SetText(" Show shrinked number");
	self.showShrinkNumCB:SetPosition( 20, 100);
	self.showShrinkNumCB:SetSize( 230, 25 );
	self.showShrinkNumCB:SetChecked(myNTAWindow.settings.shrinkNum);
	self.showShrinkNumCB.CheckedChanged = function (sender, args) myNTAWindow:shrinkNum(self.showShrinkNumCB:IsChecked()) ; end

	-- Show actual morale
	self.showAMCB = Turbine.UI.Lotro.CheckBox();
	self.showAMCB:SetParent(parent);
	self.showAMCB:SetText(" Show current");
	self.showAMCB:SetPosition( 20, 140 );
	self.showAMCB:SetSize( 230, 25 );
	self.showAMCB:SetChecked(myNTAWindow.settings.showCurrent);
	self.showAMCB.CheckedChanged = function (sender, args) myNTAWindow:showCurrent(self.showAMCB:IsChecked()) ; end

	-- Show max morale
	self.showAMMCB = Turbine.UI.Lotro.CheckBox();
	self.showAMMCB:SetParent(parent);
	self.showAMMCB:SetText(" Show max");
	self.showAMMCB:SetPosition( 20, 170);
	self.showAMMCB:SetSize( 230, 25 );
	self.showAMMCB:SetChecked(myNTAWindow.settings.showMax);
	self.showAMMCB.CheckedChanged = function (sender, args) myNTAWindow:showMax(self.showAMMCB:IsChecked()) ; end

	-- Show morale percent
	self.showPMCB = Turbine.UI.Lotro.CheckBox();
	self.showPMCB:SetParent(parent);
	self.showPMCB:SetText(" Show percent");
	self.showPMCB:SetPosition( 20, 200);
	self.showPMCB:SetSize( 230, 25 );
	self.showPMCB:SetChecked(myNTAWindow.settings.showPercent);
	self.showPMCB.CheckedChanged = function (sender, args) myNTAWindow:showPercent(self.showPMCB:IsChecked()) ; end
end

function OptionWindow:Show()
	self:SetVisible(true);
end

function OptionWindow:ColorListBoxIndex(sender)
	for i = 1, sender:GetItemCount() do
		local listItem = sender:GetItem(i);
		if (i == sender:GetSelectedIndex()) then
			listItem:SetBackColor( Turbine.UI.Color( 1, 0.4, 0.4, 0.4 ) );
		else
			listItem:SetBackColor( Turbine.UI.Color( 1, 0.3, 0.3, 0.3 ) );
		end
	end
end

function OptionWindow:EffectWindowOnlyVisibleInCombatChanged()
--	self.settings:SetEffectWindowOnlyVisibleInCombat);
end

function NTAWindow:show(flag)
	self:redraw()
	self:SaveSettings()
end


function NTAWindow:mfont(flag)
	self.settings.mfont = flag;
	self:redraw()
	self:SaveSettings()
end

function NTAWindow:shrinkNum(flag)
	self.settings.shrinkNum = flag;
	self:redraw()
	self:SaveSettings()
end

function NTAWindow:showCurrent(flag)
	self.settings.showCurrent = flag;
	self:redraw()
	self:SaveSettings()
end

function NTAWindow:showMax(flag)
	self.settings.showMax = flag;
	self:redraw()
	self:SaveSettings()
end

function NTAWindow:showPercent(flag)
	self.settings.showPercent = flag;
	self:redraw()
	self:SaveSettings()
end

